/* sf15d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__15 = 15;

doublereal sf15d_c(doublereal *x, integer *l, integer *ierr)
{
    /* Initialized data */

    static doublereal zero = 0.;
    static doublereal onep = 1.;
    static doublereal one = 1.;
    static doublereal sys059 = 1.7e308;
    static doublereal sys052 = 2.22044592e-16;
    static doublereal a[10] = { 1.494662175718133e-4,.002468503330460723,
            .008638442173604074,.01077063503986646,.007820404060959554,
            .007595093422559433,.0115695957452954,.02183181167613048,
            .05680519456755916,.4431471805608895 };
    static doublereal b[10] = { 3.185919565550157e-5,9.898332846225385e-4,
            .006432146586438302,.01680402334636338,.02614501470031388,
            .03347894366576163,.0427178905473831,.05859366125553149,
            .09374999972120314,.2499999999999018 };

    /* System generated locals */
    doublereal ret_val;

    /* Builtin functions */
    double log(doublereal);

    /* Local variables */
    static doublereal suma, sumb;
    static integer i__;
    static doublereal caysq;
    extern /* Subroutine */ int utsf11_c(integer *, integer *);
    static doublereal eta, cay;

    *ierr = 0;
    caysq = *x;
    if (*l < 1 || *l > 3) {
        goto L10;
    }
    switch (*l) {
        case 1:  goto L1;
        case 2:  goto L6;
        case 3:  goto L7;
    }
L1:
    if (caysq < zero) {
        goto L8;
    }
    eta = onep - caysq;
L2:
    if (eta < zero) {
        goto L9;
    }
L3:
    if (eta < sys052) {
        goto L5;
    }
    suma = zero;
    sumb = zero;
    for (i__ = 1; i__ <= 10; ++i__) {
        suma = (suma + a[i__ - 1]) * eta;
        sumb = (sumb + b[i__ - 1]) * eta;
/* L4: */
    }
    ret_val = suma - log(eta) * sumb;
    ret_val += one;
    goto L12;
L5:
    ret_val = onep;
    goto L12;
L6:
    cay = abs(caysq);
    eta = onep - cay;
    eta += cay * eta;
    goto L2;
L7:
    if (caysq > onep) {
        goto L9;
    }
    eta = caysq;
    goto L3;
L8:
    *ierr = 66;
    ret_val = sys059;
    goto L11;
L9:
    *ierr = 67;
    ret_val = sys059;
    goto L11;
L10:
    ret_val = sys059;
    *ierr = 65;
L11:
    utsf11_c(ierr, &c__15);
L12:
    return ret_val;
} /* sf15d_c */
